/*
Copyright (c) <2012>, Intel Corporation All Rights Reserved.
 
The source code, information and material ("Material") contained herein is owned by Intel Corporation or its suppliers or licensors, and title to such Material remains with Intel Corporation or its suppliers or licensors. The Material contains proprietary information of Intel or its suppliers and licensors. The Material is protected by worldwide copyright laws and treaty provisions. No part of the Material may be used, copied, reproduced, modified, published, uploaded, posted, transmitted, distributed or disclosed in any way without Intel's prior express written permission. No license under any patent, copyright or other intellectual property rights in the Material is granted to or conferred upon you, either expressly, by implication, inducement, estoppel or otherwise. Any license under such intellectual property rights must be express and approved by Intel in writing.
 
Copyright (c) Microsoft Corporation. All rights reserved
 
Unless otherwise agreed by Intel in writing, you may not remove or alter this notice or any other notice embedded in Materials by Intel or Intel’s suppliers or licensors in any way.
*/


function addQuestionPairListener() //add new question pair onto Set and adds a listener to the "add question" button
{

	questionSetName = document.getElementById('newSetName').value;
	questionSetDescription = document.getElementById('newSetDescription').value;
	$("#pairContainer").append("<div class=\"questionPair\" id=\"" + questionSetName + questionCounter + "\"><div class=\"questionLabel\">" + questionSetName + "#" + questionCounter + "</div><textArea class=\"createQuestionArea\">question</textArea><textArea class=\"createAnswerArea\">answer</textArea></div>");
	var childs = document.getElementById(questionSetName + questionCounter).childNodes;
	clearDefaulTextListener(childs[1], "question");
	clearDefaulTextListener(childs[2], "answer");
	questionCounter++;
	var addQuestionButton = document.getElementById("addPairButton");
	addQuestionButton.onclick = function(){
			$("#pairContainer").append("<div class=\"questionPair\" id=\"" + questionSetName + questionCounter + "\"><div class=\"questionLabel\">" + questionSetName + "#" + questionCounter + "</div><textArea class=\"createQuestionArea\">question</textArea><textArea class=\"createAnswerArea\">answer</textArea></div>");
			var childs = document.getElementById(questionSetName + questionCounter).childNodes;
			clearDefaulTextListener(childs[1], "question");
			clearDefaulTextListener(childs[2], "answer");
			questionCounter++;

	}
}


function clearDefaulTextListener(mObject, defaultText) //some boxes have default texts, this clears it
{

		mObject.onfocus = function()
		{
			if (this.value == defaultText)
				this.value = '';
		}
}

function saveSetListener() //when set is save
{

	var saveSetButton = document.getElementById('finishSetButton');
	var createPage = document.getElementById("createPage");
	saveSetButton.onclick = function()
	{
		var child = document.getElementById("pairContainer").childNodes;


		console.log(child);
		var myArray = [];
		i2 = 0;
		for(var i = child.length - 1; i > 0; i--)
		{
			var childchild = child[i].childNodes;

			myArray[i2] = {"question" : childchild[1].value, "answer" : childchild[2].value};
			i2++;

		}

		addSet(username, questionSetName, questionSetDescription, myArray)
		clearPage(document.getElementById('levelSelectPage'));

		pageTransition(document.getElementById('createPage'), document.getElementById('levelSelectPage'));
		levelSelect();

		
	}
}


function addShareSetListener() //when share is clicked
{
    document.getElementById('shareButton').onclick = function()
    {
		var child = document.getElementById("pairContainer").childNodes;


		console.log(child);
		var myArray = [];
		i2 = 0;
		for(var i = child.length - 1; i > 0; i--)
		{
			var childchild = child[i].childNodes;

			myArray[i2] = {"question" : childchild[1].value, "answer" : childchild[2].value}
			i2++;
		}

		shareSet(username, questionSetName, questionSetDescription, myArray)
		clearPage(document.getElementById('levelSelectPage'));

		addAddPorlet();
		pageTransition(document.getElementById('createPage'), document.getElementById('levelSelectPage'));
		//levelSelect();

    }
};


function shareSet(musername, msetName, msetDescription, questions) //upload set to the remote database;
{
  var transaction = db.transaction(["users"], "readwrite");
  var store = transaction.objectStore("users");

  if(db != null)
  {
    store.get(musername).onsuccess = function(event)
    {
      var user = event.target.result;

      //makes the string and sends it
      user.sets[user.sets.length] = {"name": msetName, "description" : msetDescription, "questions" : questions};
      mSetCopy = {"name": msetName, "description" : msetDescription, "questions" : questions, "creator": musername};
      setString = JSON.stringify(mSetCopy);
      var newSet = "save@-" + setString;
      console.log(newSet);

      if(connected == true)
      {
      	ws.send(newSet); 
      }

      levelSelect(user);
    }
  }
}


function addSet(musername, msetName, msetDescription, questions) //add a set to the local database
{
  var transaction = db.transaction(["users"], "readwrite");
  var store = transaction.objectStore("users");

  if(db != null)
  {
    store.get(musername).onsuccess = function(event)
    {
      var user = event.target.result;

      //add questions onto the user object
      user.sets[user.sets.length] = {"name": msetName, "description" : msetDescription, "questions" : questions};

      console.log(JSON.stringify(user));

      levelSelect(user);
      var request = store.put(user); //adds user to database;
      questionSetName = msetName;
      questionSetDescription = msetDescription;
      request.onsuccess = function()
      {
        console.log("change was sent");
      }
    }
  }
}
