/*
Copyright (c) <2012>, Intel Corporation All Rights Reserved.
 
The source code, information and material ("Material") contained herein is owned by Intel Corporation or its suppliers or licensors, and title to such Material remains with Intel Corporation or its suppliers or licensors. The Material contains proprietary information of Intel or its suppliers and licensors. The Material is protected by worldwide copyright laws and treaty provisions. No part of the Material may be used, copied, reproduced, modified, published, uploaded, posted, transmitted, distributed or disclosed in any way without Intel's prior express written permission. No license under any patent, copyright or other intellectual property rights in the Material is granted to or conferred upon you, either expressly, by implication, inducement, estoppel or otherwise. Any license under such intellectual property rights must be express and approved by Intel in writing.
 
Copyright (c) Microsoft Corporation. All rights reserved
 
Unless otherwise agreed by Intel in writing, you may not remove or alter this notice or any other notice embedded in Materials by Intel or Intel’s suppliers or licensors in any way.
*/

/**
 * Created by davebach on 6/23/2014.
 */

 //game page variables
var count = 0;
var score = 0;
var initialTime = 0;
var finalTime;
var mTimer;
var cardQuestions = document.getElementsByClassName('questionArea');
var cardAnswers = document.getElementsByClassName('answerArea');


 

function nextButtonFunction() //reset the game
{

    count = 0;
    score = 0;
    clearInterval(mTimer);
    var d = new Date();
    initialTime = d.getTime()
    document.getElementById('scoreBoard').innerHTML = "Score: " + score + "/" + document.getElementsByClassName('answerArea').length;
    mTimer = setInterval(function()
    {
        var d = new Date();
        document.getElementById('lapseTime').innerHTML = "Lapse Time: " + ((d.getTime() - initialTime)/1000) ;
    },100);

    document.getElementById('resultArea').classList.remove('thisSetOut');
    document.getElementById('resultArea').classList.remove('nextSetIn');
    document.getElementById('newLevelButton').addEventListener('click',transitionMenuSelect);
    document.getElementById('nextCardButton').addEventListener('click',nextQuestion );
    $("#nextCardButton").click();
}

function nextQuestion() //gets the next question and modify the listeners
{

    if(count != 0) {

        checkAnswer(cardAnswers[count-1].value, count-1);
        $(cardQuestions[count - 1]).blur();
        cardQuestions[count - 1].classList.remove('nextSetIn');
        cardAnswers[count - 1].classList.remove('nextSetIn');

        cardQuestions[count - 1].classList.add('thisSetOut');
        cardAnswers[count - 1].classList.add('thisSetOut');
    }

    document.getElementById('nextCardButton').removeEventListener('click', nextQuestion );

    if(count < cardAnswers.length)
    {

        cardQuestions[count].classList.add('nextSetIn');
        cardAnswers[count].classList.add('nextSetIn');
    setTimeout(function(){ //add eventlistener to question after 400ms
        if(count > 0 && cardAnswers[count-1].classList.contains('nextSetIn')) 
        {
            cardAnswers[count-1].focus(); 
            cardAnswers[count-1].onkeypress = function(e){
                if (!e) e = window.event;
                var keyCode = e.keyCode || e.which;
                if (keyCode == '13'){
                  document.getElementById('nextCardButton').addEventListener('click',nextQuestion()); //add enter listener to answer box, which presses next question button
                  return false;
            
                }
            }
        }
    }, 400);
        document.getElementById('nextCardButton').addEventListener('click',nextQuestion );
    }
    else
    { //brings up results panel
        clearInterval(mTimer); 

        var myNode = document.getElementById('resultArea');
        while(myNode.firstChild)
        {
            myNode.removeChild(myNode.firstChild);
        }
        $("#resultArea").append("<h1>" + score + "/" + document.getElementsByClassName('answerArea').length + "</h1>");
        $("#resultArea").append("<h2> Lapse Time" + document.getElementById('lapseTime').innerHTML + "</h2>");
        document.getElementById('resultArea').classList.add('nextSetIn');
        document.getElementById('nextCardButton').classList.add('invisible');
        document.getElementById('restartButton').classList.remove('invisible');
        document.getElementById('restartButton').addEventListener('click', transitionNewGame);

    }
    count++;

}


function checkAnswer(answer, questionNumber) //check the users answer with the correct answer
{
    if(answer.toUpperCase() == answers[questionNumber].toUpperCase())
    {
        document.getElementById('correctAnswerPanel').innerHTML = "Correct!";
        score = score + 1;
        console.log("correct");
        console.log("your answer: " + answer );
        console.log("the answer: " + answers[questionNumber]);
    }
    else
    {

        document.getElementById('correctAnswerPanel').innerHTML = "the correct answer was: " + answers[questionNumber];
        console.log("incorrect");
        console.log("your answer: " + answer );
        console.log("the answer: " + answers[questionNumber]);
    }
    document.getElementById('scoreBoard').innerHTML = score + "/" + document.getElementsByClassName('answerArea').length;
}


function transitionNewGame() //clears the game page
{

    document.getElementById('resultArea').classList.remove('nextSetIn');
    document.getElementById('resultArea').classList.add('thisSetOut');
    for(i = 0; i < cardQuestions.length; i++)
    {
        document.getElementById('restartButton').classList.add('invisible');
        document.getElementById('nextCardButton').classList.remove('invisible');
        cardQuestions[i].classList.remove('thisSetOut');
        cardAnswers[i].value = "";
        cardAnswers[i].classList.remove('thisSetOut');
        nextButtonFunction();
    }
    document.getElementById('correctAnswerPanel').innerHTML = "";
}

function transitionMenuSelect() //goes back to the menuSelectPage
{
    transitionNewGame();
    document.getElementById('levelSelectPage').classList.remove('invisible');
    document.getElementById('levelSelectPage').classList.remove('slideOutFadeOut');
    document.getElementById('gamePage').classList.remove('slideInFadeIn');
    document.getElementById('gamePage').classList.add('slideOutFadeOut');
    document.getElementById('levelSelectPage').classList.add('slideInFadeIn');
}

