/*
Copyright (c) <2012>, Intel Corporation All Rights Reserved.
 
The source code, information and material ("Material") contained herein is owned by Intel Corporation or its suppliers or licensors, and title to such Material remains with Intel Corporation or its suppliers or licensors. The Material contains proprietary information of Intel or its suppliers and licensors. The Material is protected by worldwide copyright laws and treaty provisions. No part of the Material may be used, copied, reproduced, modified, published, uploaded, posted, transmitted, distributed or disclosed in any way without Intel's prior express written permission. No license under any patent, copyright or other intellectual property rights in the Material is granted to or conferred upon you, either expressly, by implication, inducement, estoppel or otherwise. Any license under such intellectual property rights must be express and approved by Intel in writing.
 
Copyright (c) Microsoft Corporation. All rights reserved
 
Unless otherwise agreed by Intel in writing, you may not remove or alter this notice or any other notice embedded in Materials by Intel or Intel’s suppliers or licensors in any way.
*/

/**
 * Created by davebach on 6/20/2014.
 Login Page is the entry javascript, it is used for launching most functions that are launched at start.
 */
//database variables
var request = window.indexedDB.open("mDatabase", 2);
var db;

//socket variables
var connected = false;
var username = '';
var socket;
var ws;

//global variables for user Session
var userObject;
var questionSetName;
var questionSetDescription;
var questionCounter = 0;
var answers = [];


//when the database fails to initiate
request.onerror = function(event) { 
  console.log("Error connecting to the clientside database");
};

//when the database successfully connects
request.onsuccess = function(event) {
  db = request.result;
  console.log("your are connected to the clientside Database");
};

//when the database is upgraded to a new version
request.onupgradeneeded = function(event) {
        var db = event.target.result;
        var objectStore = db.createObjectStore("users", {keyPath: "username"}); 
}


//register user given name and password
function addUser(inputtedUsername, inputtedPassword) {
        var request = db.transaction(["users"], "readwrite")
                .objectStore("users")
                .add({ username : inputtedUsername,  password: inputtedPassword , sets: []});
                                 
        request.onsuccess = function(event) {
                alert(inputtedUsername + "could not be found in the database");
        };
         
        request.onerror = function(event) {
                alert("Unable to add data\r\nKenny is aready exist in your database! ");        
        }
         
}

//reads user and validates
function readUser(inputtedUsername, inputtedPassword) { //reader the username/password combination and validates
        var transaction = db.transaction(["users"]);
        var objectStore = transaction.objectStore("users");
        var request = objectStore.get(inputtedUsername);
        request.onerror = function(event) {
          alert("Unable to retrieve daa from database!");
        };
        request.onsuccess = function(event) {
          if(request.result) {
                userObject = request.result;

                console.log("Name: " + request.result.username + ", password: " + request.result.password + ", sets: " /* + request.result.sets[0].name*/);
                if((inputtedUsername == request.result.username) && (inputtedPassword == request.result.password))
                {
                    username = inputtedUsername;
                    pageTransition(document.getElementById('loginPage'), document.getElementById('loadingPage'));
                    loadLevels(); //if validated, the levels will be loaded for the user
                    document.getElementById('menuButton').classList.remove('invisible');
                }
                else
                    pageShake(document.getElementById('loginPage'));
                    
          } else {
                console.log(inputtedUsername + " cound not be found in your database"); 
                pageShake(document.getElementById('loginPage'));
          }
        };
}

//clear users in database
function clearAllUsers() //clears the clientside database
{
  if(db != null)
  {
    var store = db.transaction("users", "readwrite").objectStore("users");

    store.clear().onsuccess = function(event){
      alert("employee was cleared");
    }
  }
}

window.onload = function()
{

    document.getElementById('signIn').onclick = function() //logging in
    {

        // delete when finish testing
        var username = document.getElementById('username').value;
        var password = document.getElementById('password').value;


        if(username != "" && password != "")
        {


            readUser(username, password);

            //chrome.storage.local.clear(function(){});

        }

        else
        {
            document.getElementById("loginErrorMessage").innerHTML = "Incomplete Form";
        }
    }


    document.getElementById('register').onclick = function()
    {
        //addUser(username, password)
        pageTransition(document.getElementById('loginPage'), document.getElementById('registerPage'));

    }

    //adding listeners for static buttons
    addCreateSetListener();
    addShareSetListener();
    toSetMakerListener();
    saveSetListener();
    menuButtonListener();
    catalogButtonListener();
    logOutButtonListener();
    searchCatalogListener();
    creditButtonListener();
    
    document.getElementById('registerRegister').onclick = function()
    {

        var mregisterUsername = document.getElementById('registerUserName').value;
        var mregisterPassword = document.getElementById('registerPassword').value;
        pageTransition(registerPage, loginPage);

        addUser(mregisterUsername, mregisterPassword);
    }

    document.getElementById('registerCancel').onclick = function()
    {

        pageTransition(document.getElementById('registerPage'), document.getElementById('loginPage'));
    }

}

//load the levelSelectionPage and get rid of the loadingPage
function loadLevels()
{
    readUser(username, password);
    pageTransition(document.getElementById("loadingPage"), document.getElementById("levelSelectPage"));
    levelSelect(userObject);
}

//page transition in an dout
function pageTransition(pageOut, pageIn)
{
    pageOut.classList.remove('slideInFadeIn');
    pageOut.classList.add('slideOutFadeOut');
    pageOut.classList.add('invisible');
    pageIn.classList.remove('invisible');
    pageIn.classList.remove('slideOutFadeOut');
    pageIn.classList.add('slideInFadeIn');
}


function pageShake(thisPage) //shake whatever page
{
    thisPage.classList.add('shake');
    thisPage.classList.remove("slideInFadeIn");

    setTimeout(function(){
        thisPage.classList.remove('shake');
    },300)
}


function menuButtonListener() //expand and retract menu buttons
{
    var mMenuButton = document.getElementById('menuButton');
    var menu = document.getElementById('menu');
    mMenuButton.onclick = function()
    {
        if(menu.classList.contains('expand'))
        {
            menu.classList.remove('expand');
            menu.classList.add('retract');
        }
        else
        {
            menu.classList.remove('retract');
            menu.classList.add('expand');
        }
    }
}
